org 0x100
cpu 8086

jmp PreInicio

%include "dos/txt.inc"
%include "dos/lista.inc"
%include "dos/term.inc"

%include "hcasm.inc"
Importar:
    TermEscreverC:
        dw _TermEscreverC, 0
    TermEscrever:
        dw _TermEscrever, 0
    TermEscreverLocalSI:
        dw _TermEscreverLocalSI, 0
    TermEscreverRemotoSI:
        dw _TermEscreverRemotoSI, 0
    TermEscreverNro:
        dw _TermEscreverNro, 0
    TxtIgual:
        dw _TxtIgual, 0
    TxtCopiar:
        dw _TxtCopiar, 0
    TxtIgualLocal:
        dw _TxtIgualLocal, 0
    TxtCopiarLocal:
        dw _TxtCopiarLocal, 0
    TxtIgualRemoto:
        dw _TxtIgualRemoto, 0
    TxtCopiarRemoto:
        dw _TxtCopiarRemoto, 0
    TxtTamLocal:
        dw _TxtTamLocal, 0
    TxtTamRemoto:
        dw _TxtTamRemoto, 0
    ListaRemotoPreparar:
        dw _ListaRemotoPreparar, 0
    ListaRemotoInserir:
        dw _ListaRemotoInserir, 0
    ListaRemotoLer:
        dw _ListaRemotoLer, 0
    ListaRemotoLerSI:
        dw _ListaRemotoLerSI, 0
    ListaRemotoLerDS:
        dw _ListaRemotoLerDS, 0
    ListaRemotoLerES:
        dw _ListaRemotoLerES, 0
    ListaRemotoRemover:
        dw _ListaRemotoRemover, 0
    ListaLocalPreparar:
        dw _ListaLocalPreparar, 0
    ListaLocalInserir:
        dw _ListaLocalInserir, 0
    ListaLocalLer:
        dw _ListaLocalLer, 0
    ListaLocalLerSI:
        dw _ListaLocalLerSI, 0
    ListaLocalLerDS:
        dw _ListaLocalLerDS, 0
    ListaLocalLerES:
        dw _ListaLocalLerES, 0
    ListaLocalRemover:
        dw _ListaLocalRemover, 0
    dw 0

PreInicio:
    mov ax, cs
    mov ds, ax
    mov es, ax
    mov si, Importar
    .arrumarImportar:
        cmp word [si], 0
        je .fimArrumar
        mov [si + 2], ax
        add si, 4
        jmp .arrumarImportar
    .fimArrumar:
    mov si, 0x81
    mov di, Params.Dados
    mov dx, 0
    xor cx, cx
    mov cl, [0x80]
    cmp cx, 0
    je .fimProc
    .procArgs:
        lodsb
        cmp al, 0xd
        je .fim
        cmp dx, 1
        je .argComum
        cmp dx, 2
        je .argAspas
        cmp al, ' '
        je .fimProc
        cmp al, 9
        je .fimProc
            inc di
            inc word [Params.Quantidade]
            mov bx, [Params.Quantidade]
            dec bx
            shl bx, 1
            mov [bx + Params.Lista], di
            cmp al, '"'
            je .aspas
                stosb
                mov dx, 1
                jmp .fimProc
            .aspas:
                mov dx, 2
                jmp .fimProc
        .argComum:
            cmp al, ' '
            je .fimArg
            cmp al, 9
            je .fimArg
            stosb
            jmp .fimProc
        .argAspas:
            cmp al, '"'
            je .fimArg
            stosb
            jmp .fimProc
        .fimArg:
            mov dx, 0
        .fimProc:
        loop .procArgs
    .fim:
    mov ax, ds
    add ax, 0x1000
    mov es, ax
    mov cx, 1024
    mov di, _Fim
    call far [ListaLocalPreparar]
    xor ax, ax
    xor bx, bx
    xor cx, cx
    xor dx, dx
    xor si, si
    mov di, Params
    push cs
    call Inicial
    mov ah, 0x4c
    int 0x21
    

_MemFinal:
    retf

_MemAlocar:
    push ax
    push bx
    
    pop bx
    pop ax
    retf

Params:
    .Capacidade: dw 32
    .Quantidade: dw 0
    .Lista: times 32 dw 0
    .Dados: times 256 db 0



_Fim:
